
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java 实现任意N阶幻方的构造 / 憋错料</title>

    <meta name="description" content="Java 实现任意N阶幻方的构造 一.关于单偶数阶幻方和双偶数阶幻方 (一)单偶数阶幻方(即当n=4k+2时) 任何4k+2 阶幻方都可由2k+1阶幻方与2×2方块复合而成,6是此类型的最小阶. 以6阶为例,可由3阶幻方与由0,1,2,3组成的2×2的小方块拼成一个6×6的大方块复合而成. 其中,3阶幻方(洛书)如下图1所示, (图1) 800x600 Normal 0 7.8 磅 0 2 false false false EN-US ZH-CN X-NONE MicrosoftInternetExplorer4 /* Sty">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java 实现任意N阶幻方的构造</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一、关于单偶数阶幻方和双偶数阶幻方</p>
<p>（一）单偶数阶幻方（即当n=4k+2时）</p>
<p>　　任何4k+2 阶幻方都可由2k+1阶幻方与2&times;2方块复合而成，6是此类型的最小阶。</p>
<p>　　以6阶为例，可由3阶幻方与由0,1,2,3组成的2&times;2的小方块拼成一个6&times;6的大方块复合而成。</p>
<p>其中，3阶幻方（洛书）如下图1所示，</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0NzMzNzA5LTEwOTc0NzU5NjcucG5n.jpg" /></p>
<p>（图1）</p>
<p>800x600</p>
<p>Normal<br />
  0</p>
<p>7.8 磅<br />
  0<br />
  2</p>
<p>false<br />
  false<br />
  false</p>
<p>EN-US<br />
  ZH-CN<br />
  X-NONE</p>
<p>MicrosoftInternetExplorer4</p>
<p>/* Style Definitions */<br />
 table.MsoNormalTable<br />
	{mso-style-name:普通表格;<br />
	mso-tstyle-rowband-size:0;<br />
	mso-tstyle-colband-size:0;<br />
	mso-style-noshow:yes;<br />
	mso-style-priority:99;<br />
	mso-style-parent:"";<br />
	mso-padding-alt:0cm 5.4pt 0cm 5.4pt;<br />
	mso-para-margin:0cm;<br />
	mso-para-margin-bottom:.0001pt;<br />
	mso-pagination:widow-orphan;<br />
	font-size:10.0pt;<br />
	font-family:"Times New Roman","serif";}</p>
<p>将每一单元格分成4等块，各小块的值与单元格的值相同，则行和、列和、对角和均为30，（见图2），记为方阵M</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0OTAxMTE2LTEwNTcwNTczMzQucG5n.jpg" /></p>
<p>（图2）</p>
<p>800x600</p>
<p>Normal<br />
  0</p>
<p>7.8 磅<br />
  0<br />
  2</p>
<p>false<br />
  false<br />
  false</p>
<p>EN-US<br />
  ZH-CN<br />
  X-NONE</p>
<p>MicrosoftInternetExplorer4</p>
<p>/* Style Definitions */<br />
 table.MsoNormalTable<br />
	{mso-style-name:普通表格;<br />
	mso-tstyle-rowband-size:0;<br />
	mso-tstyle-colband-size:0;<br />
	mso-style-noshow:yes;<br />
	mso-style-priority:99;<br />
	mso-style-parent:"";<br />
	mso-padding-alt:0cm 5.4pt 0cm 5.4pt;<br />
	mso-para-margin:0cm;<br />
	mso-para-margin-bottom:.0001pt;<br />
	mso-pagination:widow-orphan;<br />
	font-size:10.0pt;<br />
	font-family:"Times New Roman","serif";}</p>
<p>用由0,1,2,3组成的2&times;2的小方块拼成一个6&times;6的大方块，使其行和、列和、对角和均为9，记为方阵N，（见图3）</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0OTU4NTA2LTIwNDI1NDk1NjUucG5n.jpg" /></p>
<p>（图3）</p>
<p>800x600</p>
<p>Normal<br />
  0</p>
<p>7.8 磅<br />
  0<br />
  2</p>
<p>false<br />
  false<br />
  false</p>
<p>EN-US<br />
  ZH-CN<br />
  X-NONE</p>
<p>MicrosoftInternetExplorer4</p>
<p>/* Style Definitions */<br />
 table.MsoNormalTable<br />
	{mso-style-name:普通表格;<br />
	mso-tstyle-rowband-size:0;<br />
	mso-tstyle-colband-size:0;<br />
	mso-style-noshow:yes;<br />
	mso-style-priority:99;<br />
	mso-style-parent:"";<br />
	mso-padding-alt:0cm 5.4pt 0cm 5.4pt;<br />
	mso-para-margin:0cm;<br />
	mso-para-margin-bottom:.0001pt;<br />
	mso-pagination:widow-orphan;<br />
	font-size:10.0pt;<br />
	font-family:"Times New Roman","serif";}</p>
<p>故6阶幻方为方阵4M-N（见图4）</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE1MTI3ODM0LTEyMjk0NzY0ODQucG5n.jpg" /></p>
<p>（图4）</p>
<p>800x600</p>
<p>Normal<br />
  0</p>
<p>7.8 磅<br />
  0<br />
  2</p>
<p>false<br />
  false<br />
  false</p>
<p>EN-US<br />
  ZH-CN<br />
  X-NONE</p>
<p>MicrosoftInternetExplorer4</p>
<p>/* Style Definitions */<br />
 table.MsoNormalTable<br />
	{mso-style-name:普通表格;<br />
	mso-tstyle-rowband-size:0;<br />
	mso-tstyle-colband-size:0;<br />
	mso-style-noshow:yes;<br />
	mso-style-priority:99;<br />
	mso-style-parent:"";<br />
	mso-padding-alt:0cm 5.4pt 0cm 5.4pt;<br />
	mso-para-margin:0cm;<br />
	mso-para-margin-bottom:.0001pt;<br />
	mso-pagination:widow-orphan;<br />
	font-size:10.0pt;<br />
	font-family:"Times New Roman","serif";}</p>
<p>（二）双偶数阶幻方（即当n=4k时）</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE1MjM1NTg0LTYxMjk4NzQwLnBuZw==.jpg" /></p>
<p>800x600</p>
<p>Normal<br />
  0</p>
<p>7.8 磅<br />
  0<br />
  2</p>
<p>false<br />
  false<br />
  false</p>
<p>EN-US<br />
  ZH-CN<br />
  X-NONE</p>
<p>MicrosoftInternetExplorer4</p>
<p>/* Style Definitions */<br />
 table.MsoNormalTable<br />
	{mso-style-name:普通表格;<br />
	mso-tstyle-rowband-size:0;<br />
	mso-tstyle-colband-size:0;<br />
	mso-style-noshow:yes;<br />
	mso-style-priority:99;<br />
	mso-style-parent:"";<br />
	mso-padding-alt:0cm 5.4pt 0cm 5.4pt;<br />
	mso-para-margin:0cm;<br />
	mso-para-margin-bottom:.0001pt;<br />
	mso-pagination:widow-orphan;<br />
	font-size:10.0pt;<br />
	font-family:"Times New Roman","serif";}</p>
<p>如上图所示，数字可分为有圈型和无圈型。对任意的4k阶幻方，可将其等分为k*k个如上图所示的4&times;4元组的结构。例如8阶幻方可分成4个上述结构，无圈的按照&ldquo;自左至右、自上至下&rdquo;的顺序把1~64个数填上，有圈的先放空；有圈的按照&ldquo;自右至左，自下至上&rdquo;的顺序把1~64个数填上，无圈处暂放空。这样即可生成8阶幻方。</p>
<p>二、具体代码</p>
<pre>package MagicSquare;

import java.util.Scanner;

import javax.sql.rowset.FilteredRowSet;

public class MagicSquare {

    //奇数幻方的实现:
    //卢培步法求奇数阶幻方的函数，参数依次是储存幻方的数组的名称、幻方的阶数，
    //标志位flag(为1表示主函数直接调用求奇数阶幻方，为0表示SingleEven_Magic函数进行的调用)
    public static void  Odd_Magic(int array[][],int k ,int flag){
        int i=k,j=(k+1)/2,c=1;
        while (c&lt;=k*k) {
            array[i][j]=c;
            if (c%k==0) {//若c是k的倍数，向上走
                i-=1;
            }
            else{//若c不是k的倍数，向右下走
                i+=1;
                j+=1;
                if (i&gt;k) {
                    i=1;
                }
                if (j&gt;k) {
                    j=1;
                }
            }
            c++;
        }
        if (flag==1) {
            outputArray(array);
        }
    }

    //双偶数幻方：
    //即：阶数能够被4整除的幻方构造函数，参数依次是储存幻方的数组的名称、幻方的阶数
    public static void  DoubleEven_Magic(int array[][],int k) {
        int i=1,j,c1=1,c2=k*k;
        while (i&lt;k) {  //把4k阶看作k*k 个4*4 的方块，将主对角线和反对角线上的元素标记为 -1
            j=1;
            while (j&lt;k) {
                array[i][j]=array[i+1][j+1]=array[i+2][j+2]=array[i+3][j+3]
                        =array[i][j+3]=array[i+1][j+2]
                        =array[i+2][j+1]=array[i+3][j]= - 1;
                j+=4;
            }
            i+=4;
        }

        for(i=1;i&lt;=k;i++)
            for(j=1;j&lt;=k;j++){

                //标记为0的进行正向依次赋值（java 在整型数组实例化时将所有元素初始化赋值为0）
                if (array[i][j]==0) {
                    array[i][j]=c1;
                }
                //否则，标记为-1 的进行反向依次赋值。
                else{
                    array[i][j]=c2;
                }
                c1++;
                c2--;
            }
            outputArray(array);//输出幻方

    }

    //单偶数幻方：
      //即：阶数被4除余2的幻方构造函数，参数依次是储存幻方的数组的名称、幻方的阶数
    public static void  SingleEven_Magic(int array[][],int k) {
        int a[][]=new int[k+1][k+1];
        int b[][]=new int [k+1][k+1];
        int m[][]=new int [k/2+1][k/2+1];
        int i,j;

        Odd_Magic(m, k/2, 0);

        //由k/2奇数阶幻方衍生出1比4的k阶方阵M
        for(i=1;i&lt;=k/2;i++)
            for(j=1;j&lt;=k/2;j++){
                a[2*i-1][2*j-1]=a[2*i-1][2*j]=a[2*i][2*j-1]=a[2*i][2*j]=m[i][j];
            }

        //构造方阵N
        i=1;j=1;
        while (i&lt;k) {
            j=1;
            while (j&lt;k) {
                //上半部分A型 1230
                if (i&lt;k/2||i==k/2&amp;&amp;(j==k/2+2||j==k/2-2)||i==k/2+2&amp;&amp;j==k/2) {
                    b[i][j]=1;
                    b[i][j+1]=2;
                    b[i+1][j]=3;
                    b[i+1][j+1]=0;
                }
                //左半部分C型 3102
                else if(i==k/2&amp;&amp;j&lt;k/2-2){
                    b[i][j]=3;
                    b[i][j+1]=1;
                    b[i+1][j]=0;
                    b[i+1][j+1]=2;
                }
                //右半部分D型 2013
                else if(i==k/2&amp;&amp;j&gt;k/2+2){
                    b[i][j]=2;
                    b[i][j+1]=0;
                    b[i+1][j]=1;
                    b[i+1][j+1]=3;
                }
                //6*6 核心中央和两足 1203
                else if(i==k/2&amp;&amp;j==k/2||i==k/2+2&amp;&amp;(j==k/2+2||j==k/2-2)){
                    b[i][j]=1;
                    b[i][j+1]=2;
                    b[i+1][j]=0;
                    b[i+1][j+1]=3;
                }
                //下半部分B型 2103
                else {
                    b[i][j]=2;
                    b[i][j+1]=1;
                    b[i+1][j]=0;
                    b[i+1][j+1]=3;
                }
                j+=2;
            }
            i+=2;
        }

        for(i=1;j&lt;=k;i++)
        for(j=1;j&lt;=k;j++){
            array[i][j]=4*a[i][j]-b[i][j];  //4*M-N 幻方形式
        }
        //outputArray(array);
        System.out.println();
        //两种幻方输出时中间间隔一行；
        for(i=1;i&lt;=k;i++)
        for(j=1;j&lt;=k;j++){
            array[i][j]=a[i][j]+(k/2)*(k/2)*b[i][j];   //M+(k/2)*(k/2)*N 幻方形式

        }
         outputArray(array);
    }

    //输出幻方的函数，参数是储存幻方的数组的名称
    public static void outputArray (int array[][]) {
        for(int row=1;row&lt;array.length;row++){
            for (int column = 1; column &lt; array[row].length; column++) {
                System.out.printf("%5d",array[row][column]);
            }
            System.out.println();
        }
    }

    //测试函数
    public static void  main(String args[]) {
        int a[][];
        System.out.println("请输入幻方阶数：");
        Scanner input =new Scanner(System.in);
        int k=input.nextInt();
        a=new int[k+1][k+1];

        //阶数为2的幻方不存在
        if (k==2) {
            System.out.println("不存在阶数为2的幻方，请重新输入！");
        }
        //奇数阶幻方
        else if (k%2!=0) {
            Odd_Magic(a, k, 1);
        }
        //4k型幻方（双偶数幻方）
        else if (k%4==0) {
            DoubleEven_Magic(a, k);
        }
        //4k+2型幻方（单偶数幻方）
        else {
            SingleEven_Magic(a, k);
        }
    }
}</pre>
<p>三、结果截图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0MzA2MTc4LTExMTAyOTk2MTgucG5n.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0MzEzMzAzLTM5Njc5MDYzLnBuZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0MzIwNjQ3LTk3MTk0MTY4LnBuZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0MzI3ODAzLTYyMDkzNTk2OS5wbmc=.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0MzM3MzgxLTUzMjE1NTEwLnBuZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzgxODA4Mi8yMDE2MDUvODE4MDgyLTIwMTYwNTI4MjE0MzQ0MzM0LTM2ODk0NzUzMC5wbmc=.jpg" /></p>
<p>（相关源码详见：<a href="https://github.com/shenxiaolinZERO/Resources/tree/master/Resources/Magic_Test" rel="external nofollow noreferrer">https://github.com/shenxiaolinZERO/Resources/tree/master/Resources/Magic_Test</a>）</p>
<p>800x600</p>
<p>将每一单元格分成4等块，各小块的值与单元格的值相同，则行和、列和、对角和均为30，（见图2），记为方阵M</p>
<p>Normal<br />
  0</p>
<p>7.8 磅<br />
  0<br />
  2</p>
<p>false<br />
  false<br />
  false</p>
<p>EN-US<br />
  ZH-CN<br />
  X-NONE</p>
<p>MicrosoftInternetExplorer4</p>
<p>/* Style Definitions */<br />
 table.MsoNormalTable<br />
	{mso-style-name:普通表格;<br />
	mso-tstyle-rowband-size:0;<br />
	mso-tstyle-colband-size:0;<br />
	mso-style-noshow:yes;<br />
	mso-style-priority:99;<br />
	mso-style-parent:"";<br />
	mso-padding-alt:0cm 5.4pt 0cm 5.4pt;<br />
	mso-para-margin:0cm;<br />
	mso-para-margin-bottom:.0001pt;<br />
	mso-pagination:widow-orphan;<br />
	font-size:10.0pt;<br />
	font-family:"Times New Roman","serif";}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-07 04:12:50 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java 实现任意N阶幻方的构造的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgXxYr0.html" rel="bookmark">Java 实现奇数阶幻方的构造</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.设计的流程图如下所示 二.Java 语言的代码实现 package MagicSquare; //奇数幻方的实现 public class Magic_Odd { //n 为幻方的阶数 public static int[][] magicOdd(int n) { //构造一个(n+2)*(n+2)阶的方阵 int[][] square = new int[n + 1][n + 1]; int i = 0; int j = (n + 1) / 2; //从第一行的中间那个数字(是1)开始填幻			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0agjqE4.html" rel="bookmark">任意阶幻方的c&plus;&plus;实现----奇阶幻方、双偶幻方、单偶幻方。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				幻方分为3类.奇阶幻方(奇数).双偶幻方(能够被4整除,如8,12,16--).单偶幻方(4m+2形式,如6,10--),构造算法各不相同. 下面的程序中,奇阶幻方的构造算法为Merzirac法.双偶幻方的构造算法为Spring法.单偶幻方的构造算法为Strachey法. 单偶幻方: 在第一行居中的方格内放1,依次向右上方填入2.3.4-,如果右上方已有数字,则向下移一格继续填写. 参考:http://blog.csdn.net/zheng0518/article/details/9006281			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wEEGVM.html" rel="bookmark">任意阶幻方（魔方矩阵）C语言实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				魔方又称幻方.纵横图.九宫图,最早记录于我国古代的洛书.据说夏禹治水时,河南洛阳附近的大河里浮出了一只乌龟,背上有一个很奇怪的图形,古人认为是一种祥瑞,预示着洪水将被夏禹王彻底制服.后人称之为&quot;洛书&quot;或&quot;河图&quot;,又叫河洛图. 南宋数学家杨辉,在他著的&lt;续古摘奇算法&gt;里介绍了这种方法:只要将九个自然数按照从小到大的递增次序斜排,然后把上.下两数对调,左.右两数也对调:最后再把中部四数各向外面挺出,幻方就出现了. (摘自&lt;趣味数学辞典&gt;) 在西方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RxpXj4.html" rel="bookmark">N（奇数）阶幻方-java实现代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看完最强大脑,有一期是说N阶幻立方的,作为一个程序员,我的第一反应时我可以用程序实现,在此公布N(奇数)阶幻方的java实现代码: package com.lzugis.test; public class Practice { public static int[][] magicOdd(int n) { int[][] square = new int[n + 1][n + 1]; int i = 0; int j = (n + 1) / 2; for (int key = 1; key &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dPb1Z0.html" rel="bookmark">codeforces 710C  Magic Odd Square&lpar;构造或者n阶幻方&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Find an n × n matrix with different numbers from 1 to n2, so the sum in each row, column and both main diagonals are odd. Input The only line contains odd integer n (1 ≤ n ≤ 49). Output Print n lines with n integers. All the integers should be differ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmjggX0.html" rel="bookmark">求N奇数阶幻方</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 如果矩阵满足条件,那么对任意,也满足条件.证明显然. 设为奇数,我们现在构造一个n阶幻方包含0到所有数这里x,y满足同余式待确定. 由于该方程组的系数矩阵的行列式为1,所以对任意i,j有唯一解.我们接下来确定a,b: 首先验证每行每列的和均相等,即 由于对任意i,,当x取遍模n的剩余类时,也会取遍所有的剩余类 故每行的和为:同理验证每列. 对于对角线:令b = n - 1, a = (n-1)/2,可以验证y = (n - 1)/2, x = i所以其和为:n*(0 + ... n - 1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPRQK13.html" rel="bookmark">Tyvj1109&vert;N阶幻方</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				描述在一个由若干个排列整齐的数组成的正方形中,图中任意一横行.一纵行及对角线的几个数之和都相等,具有这种性质的图表,称为幻方.目前已经确定,N阶幻方(n&gt;=3)都可以构造出幻方.我们的问题是,当构造的幻方,任意一横行的数累加的和是多少.输入格式一个数n表示n阶幻方 n&lt;=10000输出格式一个数,任意一横行的数累加的和测试样例1输入3 输出15 备注组合数学例题 分析:套公式. #include&lt;iostream&gt; using namespace std; int main() {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YWYbO4.html" rel="bookmark">幻方的构造模板</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/* 幻方的计算: 计算任意阶数幻方的各行.各列.各条对角线上所有数的和的公式为:sum=n*(n^2+1)/2 n为阶数 幻方分为奇阶幻方和偶阶幻方 一.当n为奇数时称为奇阶幻方 1.Merzirac法生成奇阶幻方 在第一行居中的方格内放1,依次向右上方填入2.3.4…,如果右上方已有数字,则向下移一格继续填写. 2.loubere法生成奇阶幻方 在居中的方格向上一格内放1,依次向右上方填入2.3.4…,如果右上方已有数字,则向上移两格继续填写 3.horse法生成奇阶幻方 (1)对于所有的奇			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoxjyQ0.html" rel="bookmark">关于java中任意对象强制转换为接口类型的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java中任意对象强转为接口类型都不会有编译错误 public class Apple implements Eatable{ public static void main(String args[]) { Drinkable drinkable = (Drinkable)new Apple(); } } interface Eatable{} interface Drinkable{} java中的类可以多实现接口,Java编译器无法判断该类是否实现了该接口所以不会有编译错误. 但是Java			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0x17n3.html" rel="bookmark" class="title">看图说说Heap中对象的生存状态</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3OvOG0.html" rel="bookmark" class="title">Linux命令之mkdir</a>
					<div>
						mkdir命令 用处:创建文件夹 用法:在终端中输入mkdir加上文件夹的名字 示例: (我想创建一个名字为shuyunquan的文件夹)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Yg1aw4.html" rel="bookmark" class="title">iOS开发&mdash;&mdash;错误总结篇&amp;amp&semi;开发中常见错误和警告总结（三十三）</a>
					<div>
						开发中常见错误和警告总结(三十三) 动画冲突 错误: Unbalanced calls to begin/end appearance transitions for &lt;uivewcontrol ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pevrJM.html" rel="bookmark" class="title">SAPUI5拓展标准应用的Controller原理分析及应用实践</a>
					<div>
						前言 鉴于SAP S/4 HANA的世界性普及,外加中国区云服务的正式落地,作为SAP 移动端用户体验的自有H5框架,也愈加备受关注, 目前SAP大部分产品都是基于SAP Fiori进行定制开发,因此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Addav3.html" rel="bookmark" class="title">SpringAOP拦截Controller&comma;Service实现日志管理&lpar;自定义注解的方式&rpar;</a>
					<div>
						首先我们为什么需要做日志管理,在现实的上线中我们经常会遇到系统出现异常或者问题.这个时候就马上打开CRT或者SSH连上服务器拿日子来分析.受网络的各种限制.于是我们就想为什么不能直接在管理后台查看报错 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZlmZ0.html" rel="bookmark" class="title">vs的【warning C4996&colon;&amp;&num;39&semi;fopen&amp;&num;39&semi;&colon; This function or variable may be unsafe】解决方案</a>
					<div>
						转载自:http://my.oschina.net/liujinofhome/blog/36287 以及http://blog.sina.com.cn/s/blog_562f523f0100rezj. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAl2Z3.html" rel="bookmark" class="title">NuGet包断线续传下载</a>
					<div>
						(金庆的专栏) NuGet是VC的扩展,用来下载依赖包.NuGet下载没有断线续传,下载源又很容易断开.  https://nuget.org/api/v2/  https://go.microsof ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415JWk4.html" rel="bookmark" class="title">继承过程中对函数中this的认识</a>
					<div>
						1 &lt;!DOCTYPE html&gt; 2 &lt;html lang=&quot;en&quot;&gt; 3 &lt;head&gt; 4 &lt;meta charset=&quot;U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME8nLZ4.html" rel="bookmark" class="title">hdu - 3594 Cactus &lpar;强连通&rpar;</a>
					<div>
						http://acm.hdu.edu.cn/showproblem.php?pid=3594 判断给定的图是否是强连通的,并且每条边都只属于一个连通分量. 判断强连通只需要判断缩点之后顶点数是否为1即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz11N24.html" rel="bookmark" class="title">Xbox One：通过二维码快速安装游戏</a>
					<div>
						如果你购买的是Xbox 360的游戏,并且是下载方式的.那你就需要用手柄输入25位的字母数字组合,这样真的很麻烦. Xbox One的游戏任然带有25位的序列号,但是同时还有一个二维码,这个二维码正式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jnqaE0.html" rel="bookmark" class="title">流行框架阶段&amp;&num;183&semi;概览</a>
					<div>
						1. 现在有什么东西在流行,我们要学什么? 流行框架阶段的学习,大部分经历会花在AngularJs的框架的学习上. 不过,在真正开始学习AngularJs框架之前,还可以花一点小时间,带领大家认识一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYoxq4.html" rel="bookmark" class="title">源泉书签，助您管理海量收藏。今日更新【里程碑】支持书签导出功能了，从此不怕网络书签丢失了，随时随地备份您的书签。</a>
					<div>
						源泉书签,助您管理海量收藏,www.yuanquanshuqian.com:今日更新[里程碑]支持书签导出功能了,从此不怕网络书签丢失了,随时随地备份您的书签. 版权声明:本文为博主原创文章,未经博主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNk9J0.html" rel="bookmark" class="title">RootSudo</a>
					<div>
						Note: For help with configuring sudo privileges via its configuration file /etc/sudoers, please see  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47eoBR0.html" rel="bookmark" class="title">最小树形图&lpar;模板&rpar;</a>
					<div>
						本文链接:http://www.cnblogs.com/Ash-ly/p/5536796.html 定义: 设G = (V, E)是一个有向图,如果具有下述性质 (1)G中不包含有向环; (2)存在一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJg8D3.html" rel="bookmark" class="title">连连看的原生JS实现</a>
					<div>
						那天闲来无事,便想找个小游戏来打发时间,后来便找到了连连看, 玩了一会儿感觉无聊,想到各位高手用JS做的各种小游戏,便想自己也来做一个,于是便有了这几天的成果. 代码是用 原生JS 实现的,只是用来学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/351mLR3.html" rel="bookmark" class="title">配置guzz&period;xml</a>
					<div>
						核心配置 guzz.xml为guzz框架的核心配置文件,用于定义应用配置,数据库使用,ORM,以及服务等. guzz.xml样本: 1 &lt;guzz-configs&gt; 2 3 &lt;con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8zjO3.html" rel="bookmark" class="title">七天来学习ASP&period;NET MVC &lpar;两&rpar;&mdash;&mdash;ASP&period;NET MVC 数据传输</a>
					<div>
						通过第一天的学习之后,我们相信您已经对MVC有一些基本了解. 本节所讲的内容是在上节的基础之上.因此须要确保您是否掌握了上一节的内容. 本章的目标是在今天学习结束时利用最佳实践解决方式创建一个小型的M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDde8M.html" rel="bookmark" class="title">模块（Modules）</a>
					<div>
						一.引入模块 模块:当编写更大的应用程序时,所有的代码肯定会分成多个文件,这样便于维护,另外已经编写好的函数和对象在被多个程序中使用时,不用把函数和对象拷贝到每个程序中. 模块支持以上功能,在Pyth ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35PnvX0.html" rel="bookmark" class="title">AFNetworking  使用 核心代码</a>
					<div>
						///////////////////////////以前用法///////////////////////////////////////////////////////////// //使用AFH ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YL6DOM.html" rel="bookmark" class="title">MySQL&lpar;三&rpar; 数据库表的查询操作【重要】</a>
					<div>
						序言 1.MySQL表操作(创建表,查询表结构,更改表字段等), 2.MySQL的数据类型(CHAR.VARCHAR.BLOB,等), 本节比较重要,对数据表数据进行查询操作,其中可能大家不熟悉的就对 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
